//---------------------------------------------------------------------------
// Made by luc.jaulin@univ-angers.fr
// For details, see  L. Jaulin,  I. Braems,  M. Kieffer and E. Walter (2000),
// Nonlinear State Estimation Using Forward-Backward Propagation of Intervals,
// SCAN/INTERVAL2000,  Karlsruhe (Germany),  191-204.
// Download the paper at http/istia.univ-angers/~jaulin/x0.zip
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fiche.h"
#include "box.h"
#include "repere.h"
#include "algo.cpp"
#include "iboolean.cpp"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
box X0(2,true);   //Box which contains the initial state vector (x1(0),x2(0))
int i=0;    //number of clicks onto the button "GO"
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
AnsiString Chaine(box& B)  //generates a string for the box B
{   AnsiString s="";
    for (int i=1;i<=B.dim;i++)
    {   s=s+"["+Inf(B[i])+" , "+Sup(B[i])+"]";
        if (i!=B.dim) s=s+" X ";
    }
    return s;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClick(TObject *Sender)
{   ButtonGo->Visible=true;
    Memo1->Visible=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonGoClick(TObject *Sender)
{   ButtonInitClick(Sender);
    clock_t start, end;
    start = clock();
    repere R(this,Inf(X0[1]),Sup(X0[1]),Inf(X0[2]),Sup(X0[2]));
    R.DrawBox(X0,clWhite,clWhite,bsSolid);
    Go(R,X0,i);
    i=i+1;
    if (i==5) i=0;
    end = clock();
    Memo1->Text=Text+ "   X0   = "+Chaine(X0);
    Memo1->Text=Memo1->Text+ ", Computing time = " +((end-start)/CLK_TCK);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonInitClick(TObject *Sender)
{
    Memo1->Visible=false;
    ButtonGo->Visible=false;
    X0[1]=interval(-1.2,-0.8);	X0[2]=interval(-0.2,0.2);
}
//---------------------------------------------------------------------------


